unit CopyProp;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TCopyProp = class(TForm)
    Button_All   : TButton;
    Button_Cancel: TButton;
    Button_Ok    : TButton;
    Btn_B        : TRadioButton;
    Btn_N        : TRadioButton;
    Btn_O        : TRadioButton;
    Btn_R        : TRadioButton;
    Btn_S        : TRadioButton;
    Btn_U        : TRadioButton;
    GroupBox1    : TGroupBox;
    Label1       : TLabel;
    Label2       : TLabel;
    Label3       : TLabel;
    Label4       : TLabel;
    Label5       : TLabel;
    SText_DstDate: TStaticText;
    SText_DstSize: TStaticText;
    SText_SrcDate: TStaticText;
    SText_SrcSize: TStaticText;
    procedure Button_AllClick(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
    procedure GetProperty;
    procedure SetButton;
  public
    { Public 錾 }
    procedure SetEachFont;
  end;

procedure ShowCopyPropDialog;

var
  CopyProp1: TCopyProp;

implementation

{$R *.DFM}

uses Zfd;

//---------------------------------------------------------------------------------------------------------------------------------------------------

// _CAO\̏
procedure TCopyProp.FormShow(Sender: TObject);
begin
  CopyProp1.Caption := Form1.Caption;
  Label1   .Caption := sCopyProp;

  SetButton;

  SText_DstDate.Caption := cpDstDate;
  SText_DstSize.Caption := cpDstSize;
  SText_SrcDate.Caption := cpSrcDate;
  SText_SrcSize.Caption := cpSrcSize;

  F_RepCopy := False;
  F_CopyPr  := True;
end;

// e{^ݒ肷
procedure TCopyProp.SetButton;
begin
  if F_SameDir then
  begin
    Btn_B.Enabled := False;
    Btn_N.Enabled := False;
    Btn_O.Enabled := False;
    Btn_S.Enabled := False;
    Btn_U.Enabled := False;

    Btn_R.Checked := True;
    Btn_R.SetFocus;
  end
  else
  case cMode of
    cpB: begin
           Btn_B.Checked := True;
           Btn_B.SetFocus;
         end;
    cpN: begin
           Btn_N.Checked := True;
           Btn_N.SetFocus;
         end;
    cpO: begin
           Btn_O.Checked := True;
           Btn_O.SetFocus;
         end;
    cpR: begin
           Btn_R.Checked := True;
           Btn_R.SetFocus;
         end;
    cpS: begin
           Btn_S.Checked := True;
           Btn_S.SetFocus;
         end;
    cpU: begin
           Btn_U.Checked := True;
           Btn_U.SetFocus;
         end;
  end;
end;

// e{^ݒ𓾂
procedure TCopyProp.GetProperty;
begin
  if F_SameDir     then // Ȃ
  else
  if Btn_B.Checked then cMode := cpB
  else
  if Btn_N.Checked then cMode := cpN
  else
  if Btn_O.Checked then cMode := cpO
  else
  if Btn_R.Checked then cMode := cpR
  else
  if Btn_S.Checked then cMode := cpS
  else                  cMode := cpU;
end;

// L[͂ɂݒ
procedure TCopyProp.FormKeyPress(Sender: TObject; var Key: Char);
var s: String;
begin
  s := Key;
  s := AnsiUpperCase(s);

  case s[1] of
    'A': Button_ALLClick(Sender);
    'B': Btn_B.Checked := True;
    'N': Btn_N.Checked := True;
    'O': Btn_O.Checked := True;
    'R': Btn_R.Checked := True;
    'S': Btn_S.Checked := True;
    'U': Btn_U.Checked := True;
  end;

  Key := #0;
end;

// nj{^̏
procedure TCopyProp.Button_OkClick(Sender: TObject);
begin
  GetProperty;

  ModalResult := mrOK;
end;

// ALL{^̏
procedure TCopyProp.Button_AllClick(Sender: TObject);
begin
  F_RepCopy := True;

  Button_OkClick(Sender);
end;

// LZ{^̏
procedure TCopyProp.Button_CancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure ShowCopyPropDialog;
begin
  CopyProp1 := TCopyProp.Create(Application);
  CopyProp1.ShowModal;
end;

procedure TCopyProp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

//--------------------------------------------------------
// CtH[̃tHgeIuWFNgɐݒ
//--------------------------------------------------------
procedure TCopyProp.SetEachFont;
var fSize: Integer; fFont: TFont;
begin
  fFont := Form1.Font;

  Button_All   .Font := fFont;
  Button_Cancel.Font := fFont;
  Button_Ok    .Font := fFont;
  Btn_B        .Font := fFont;
  Btn_N        .Font := fFont;
  Btn_O        .Font := fFont;
  Btn_R        .Font := fFont;
  Btn_S        .Font := fFont;
  Btn_U        .Font := fFont;
  GroupBox1    .Font := fFont;
  Label1       .Font := fFont;
  Label2       .Font := fFont;
  Label3       .Font := fFont;
  Label4       .Font := fFont;
  Label5       .Font := fFont;
  SText_DstDate.Font := fFont;
  SText_DstSize.Font := fFont;
  SText_SrcDate.Font := fFont;
  SText_SrcSize.Font := fFont;

  fSize := Form1.Font.Size - 2;
  if fSize > MaxDlgFsize then fSize := MaxDlgFsize;

  Button_All   .Font.Size := fSize;
  Button_Cancel.Font.Size := fSize;
  Button_Ok    .Font.Size := fSize;
  Btn_B        .Font.Size := fSize;
  Btn_N        .Font.Size := fSize;
  Btn_O        .Font.Size := fSize;
  Btn_R        .Font.Size := fSize;
  Btn_S        .Font.Size := fSize;
  Btn_U        .Font.Size := fSize;
  GroupBox1    .Font.Size := fSize;
  Label1       .Font.Size := fSize;
  Label2       .Font.Size := fSize;
  Label3       .Font.Size := fSize;
  Label4       .Font.Size := fSize;
  Label5       .Font.Size := fSize;
  SText_DstDate.Font.Size := fSize;
  SText_DstSize.Font.Size := fSize;
  SText_SrcDate.Font.Size := fSize;
  SText_SrcSize.Font.Size := fSize;
end;

procedure TCopyProp.FormCreate(Sender: TObject);
begin
  SetEachFont;
end;

procedure TCopyProp.FormDestroy(Sender: TObject);
begin
  F_CopyPr := False;
end;

end.
