unit LogHist;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  THistDlg = class(TForm)
    Button_Cancel: TButton;
    Button_Ok    : TButton;
    Edit1        : TEdit;
    Label1       : TLabel;
    Label2       : TLabel;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure SetEachFont;
  end;

procedure ShowHistDialog;

var
  HistDlg1: THistDlg;

implementation

{$R *.DFM}

uses Zfd, SubRoutines;

var
  HistIndex: Integer;

//---------------------------------------------------------------------------------------------------------------------------------------------------

function IsCopyHistL: Boolean;
begin
  Result := (AnsiPos('Rs[', sDspHist1) > 0) or
            (AnsiPos('[u', sDspHist1) > 0);
end;

function IsLogHistL: Boolean;
begin
  Result := (AnsiPos('hCu', sDspHist1) > 0);
end;

function IsZipHistL: Boolean;
begin
  Result := (AnsiPos('kt@C', sDspHist1) > 0);
end;

// \̏
procedure THistDlg.FormShow(Sender: TObject);
begin
  HistDlg1.Caption := Form1.Caption;
  Label1  .Caption := sDspHist1;
  Label2  .Caption := sDspHist2;

  if IsCopyHistL or
     IsLogHistL  then
  begin
    // Copy, Logp
    if HistList.Count > 0 then
    begin
      HistIndex := 0;

      Edit1.Text := HistList[HistIndex];
    end
    else
    begin
      HistIndex := -1;

      Edit1.Text := fDir;
    end;
  end
  else
  if IsZipHistL then
  begin
    // Zipp
    if HistList.Count > 0 then
    begin
      HistIndex := 0;

      Edit1.Text := ExtractFileName(HistList[HistIndex]);
    end
    else
    begin
      HistIndex := -1;

      Edit1.Text := '';
    end;
  end;

  Edit1.SetFocus;

  F_LogHist := True;
end;

// OK{^̏
procedure THistDlg.Button_OkClick(Sender: TObject);
var n: Integer; s: String; c: Char;
begin
  s := TrimRight(Edit1.Text);

  if IsCopyHistL or
     IsLogHistL  then
  begin
    // Copy, Logp
    if Length(s) = 1 then
    begin
      // hCuP̏ꍇ
      c := Char(AnsiUpperCase(s)[1]);

      if CharInSet(c, [#65{A}..#90{Z}]) then
      begin
        s := dLst[Ord(AnsiUpperCase(s)[1])-Ord('A')];
      end;
    end;

    // LpXgXV
    UpdateDirList(s, HistList);

    // @Rs[Ȃnj
    // ALȃpXł΂nj
    if IsCopyHistL                                 or
       ((s <> '') and SysUtils.DirectoryExists(s)) then
    begin
      ModalResult := mrOK;
    end
    else
    // ȃpX͍폜
    begin
      HistList.Delete(0);

      MsgDlg('w肳ꂽpX݂͑܂');
      ModalResult := mrCancel;
    end;
  end
  else
  if IsZipHistL then
  begin
    // Zipp
    s := ChangeFileExt(s, '.zip');       // gqύX
    s := fDir + ExtractFileName(s);      // tpX

    n := HistList.IndexOf(s);            // ̂邩
    if n > -1 then HistList.Delete(n);   // ΍폜

    HistList.Insert(0, s);               // ԏɓ
    while HistList.Count > MaxHistNum do // ő吔𒴂Ō폜
    begin                                // ComboB̓eƐHĂ
      HistList.Delete(HistList.Count-1); // ̋Nňv
    end;

    ModalResult := mrOK;
  end
  else
  begin
    ModalResult := mrCancel;
  end;
end;

// LZ{^̏
procedure THistDlg.Button_CancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure ShowHistDialog;
begin
  HistDlg1 := THistDlg.Create(Application);
  HistDlg1.Hide;
  HistDlg1.ShowModal;
end;

procedure THistDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

//--------------------------------------------------------
// CtH[̃tHgeIuWFNgɐݒ
//--------------------------------------------------------
procedure THistDlg.SetEachFont;
var fSize: Integer; fFont: TFont;
begin
  fFont := Form1.Font;

  Button_Cancel.Font := fFont;
  Button_Ok    .Font := fFont;
  Edit1        .Font := fFont;
  Label1       .Font := fFont;
  Label2       .Font := fFont;

  fSize := Form1.Font.Size - 2;
  if fSize > MaxDlgFsize then fSize := MaxDlgFsize;

  Button_Cancel.Font.Size := fSize;
  Button_Ok    .Font.Size := fSize;
  Edit1        .Font.Size := fSize;
  Label1       .Font.Size := fSize;
  Label2       .Font.Size := fSize;
end;

procedure THistDlg.FormCreate(Sender: TObject);
begin
  SetEachFont;
end;

procedure THistDlg.FormDestroy(Sender: TObject);
begin
  F_LogHist := False;
end;

procedure DecHistIndex;
begin
  if HistIndex > 0 then Dec(HistIndex);
end;

procedure IncHistIndex;
begin
  if HistIndex < HistList.Count - 1 then Inc(HistIndex);
end;

function GetHitList: String;
begin
  if (HistIndex >= 0)              and
     (HistIndex <  HistList.Count) then Result := HistList[HistIndex]
  else                                  Result := '';
end;

procedure THistDlg.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of
    vk_Escape: begin
                 Button_CancelClick(Sender);

                 Key := 0;
               end;
    vk_Left  : begin
               end;
    vk_Up    : begin
                 IncHistIndex;

                 if IsZipHistL then Edit1.Text := ExtractFileName(GetHitList)
                 else               Edit1.Text :=                 GetHitList;

                 Edit1.SelectAll;

                 Key := 0;
               end;
    vk_Right : begin
               end;
    vk_Down  : begin
                 DecHistIndex;

                 if IsZipHistL then Edit1.Text := ExtractFileName(GetHitList)
                 else               Edit1.Text :=                 GetHitList;

                 Edit1.SelectAll;

                 Key := 0;
               end;
    vk_Return: begin
               end;
  end;
end;

end.
