unit MakeDir;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TMakeDir = class(TForm)
    Button_Cancel: TButton;
    Button_Ok    : TButton;
    Edit1        : TEdit;
    Label1       : TLabel;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure SetEachFont;
  end;

procedure ShowMakeDirDialog;

var
  MakeDir1: TMakeDir;

implementation

{$R *.DFM}

uses Zfd;

//---------------------------------------------------------------------------------------------------------------------------------------------------

// \̏
procedure TMakeDir.FormShow(Sender: TObject);
begin
  MakeDir1.Caption := Form1.Caption;
  Label1  .Caption := sMakeDir;

  Edit1.Text := sMakeTxt1;
  Edit1.SetFocus;

  F_MakeDir := True;
end;

// OK{^̏
procedure TMakeDir.Button_OkClick(Sender: TObject);
begin
  sMakeTxt2   := TrimRight(Edit1.Text);
  ModalResult := mrOK;
end;

// LZ{^̏
procedure TMakeDir.Button_CancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure ShowMakeDirDialog;
begin
  MakeDir1 := TMakeDir.Create(Application);
  MakeDir1.Hide;
  MakeDir1.ShowModal;
end;

procedure TMakeDir.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

//--------------------------------------------------------
// CtH[̃tHgeIuWFNgɐݒ
//--------------------------------------------------------
procedure TMakeDir.SetEachFont;
var fSize: Integer; fFont: TFont;
begin
  fFont := Form1.Font;

  Button_Cancel.Font := fFont;
  Button_Ok    .Font := fFont;
  Edit1        .Font := fFont;
  Label1       .Font := fFont;

  fSize := Form1.Font.Size - 2;
  if fSize > MaxDlgFsize then fSize := MaxDlgFsize;

  Button_Cancel.Font.Size := fSize;
  Button_Ok    .Font.Size := fSize;
  Edit1        .Font.Size := fSize;
  Label1       .Font.Size := fSize;
end;

procedure TMakeDir.FormCreate(Sender: TObject);
begin
  SetEachFont;
end;

procedure TMakeDir.FormDestroy(Sender: TObject);
begin
  F_MakeDir := False;
end;

end.
