unit MsgBox;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TMsgBox = class(TForm)
    Button_Cancel: TButton;
    Button_Ok    : TButton;
    Label1       : TLabel;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure SetEachFont;
  end;

procedure ShowMsgBox;

var
  MsgBox1: TMsgBox;

implementation

{$R *.DFM}

uses Zfd;

//---------------------------------------------------------------------------------------------------------------------------------------------------

// \̏
procedure TMsgBox.FormShow(Sender: TObject);
begin
  MsgBox1.Caption := Form1.Caption;
  Label1 .Caption := sMsgBox;

  F_MsgBox := True;
end;

// OK{^̏
procedure TMsgBox.Button_OkClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

// LZ{^̏
procedure TMsgBox.Button_CancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure ShowMsgBox;
begin
  MsgBox1 := TMsgBox.Create(Application);
  MsgBox1.Hide;
  MsgBox1.ShowModal;
end;

procedure TMsgBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

//--------------------------------------------------------
// CtH[̃tHgeIuWFNgɐݒ
//--------------------------------------------------------
procedure TMsgBox.SetEachFont;
var fSize: Integer; fFont: TFont;
begin
  fFont := Form1.Font;

  Button_Cancel.Font := fFont;
  Button_Ok    .Font := fFont;
  Label1       .Font := fFont;

  fSize := Form1.Font.Size - 2;
  if fSize > MaxDlgFsize then fSize := MaxDlgFsize;

  Button_Cancel.Font.Size := fSize;
  Button_Ok    .Font.Size := fSize;
  Label1       .Font.Size := fSize;
end;

procedure TMsgBox.FormCreate(Sender: TObject);
begin
  SetEachFont;
end;

procedure TMsgBox.FormDestroy(Sender: TObject);
begin
  F_MsgBox := False;
end;

end.
