unit Qaccess;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TQaccess = class(TForm)
    Button_Cancel: TButton;
    Button_DelDir: TButton;
    Button_Ok    : TButton;
    Button_RegDir: TButton;
    Label1       : TLabel;
    LBox_DirList : TListBox;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_DelDirClick(Sender: TObject);
    procedure Button_OkClick    (Sender: TObject);
    procedure Button_RegDirClick(Sender: TObject);
    procedure LBox_DirListDblClick(Sender: TObject);
    procedure FormClose  (Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow   (Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure SetEachFont;
  end;

procedure ShowQaccessDialog;

const
  MaxDirNum = 100;

var
  Qaccess1: TQaccess;
  F_SelDir: Boolean; // fBNgIp

implementation

{$R *.DFM}

uses Zfd;

//---------------------------------------------------------------------------------------------------------------------------------------------------

// \̏
procedure TQaccess.FormShow(Sender: TObject);
begin
  Qaccess1.Caption := Form1.Caption;
  Label1  .Caption := sQaccess;

  if AnsiPos('fBNg', sQaccess) > 0 then
  begin
    // pANZXp
    F_SelDir := True;

    with LBox_DirList do
    begin
      Items.Assign(QaccssList);

      if Items.Count > -1 then ItemIndex := 0;

      SetFocus;
    end;
  end
  else
  begin
    // Copy, MovepF\̂
    F_SelDir := False;

    Button_Cancel.Visible := False;
    Button_DelDir.Visible := False;
    Button_RegDir.Visible := False;

    with LBox_DirList do
    begin
      Items.Assign(ReportList);
      ItemIndex := -1;
    end;
  end;

  F_Qaccess := True;
end;

procedure TQaccess.LBox_DirListDblClick(Sender: TObject);
begin
  if F_SelDir then Button_OkClick(Sender);
end;

// OK{^̏
procedure TQaccess.Button_DelDirClick(Sender: TObject);
begin
  if F_SelDir then
  begin
    with LBox_DirList do
    begin
      if ItemIndex > -1 then
      begin
        Items.Delete(ItemIndex);

        QaccssList.Assign(Items);
      end;

      SetFocus;
    end;
  end;
end;

procedure TQaccess.Button_OkClick(Sender: TObject);
var s: String;
begin
  if F_SelDir then
  begin
    with LBox_DirList do
    begin
      if ItemIndex > 0 then
      begin
        s := Items[ItemIndex];
        Items.Delete(ItemIndex);
        Items.Insert(0, s);

        QaccssList.Assign(Items);
      end;
    end;
  end;

  ModalResult := mrOK;
end;

procedure TQaccess.Button_RegDirClick(Sender: TObject);
var n: Integer;
begin
  with LBox_DirList do
  begin
    n := Items.IndexOf(fDir);        // ̂邩
    if n > -1 then Items.Delete(n);  // ΍폜

    Items.Insert(0, fDir);           // ԏɓ
    ItemIndex := 0;

    while Items.Count > MaxDirNum do // ő吔𒴂Ō폜
    begin
      Items.Delete(Items.Count-1);
    end;

    QaccssList.Assign(Items);
  end;

  SetFocus;
end;

// LZ{^̏
procedure TQaccess.Button_CancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure ShowQaccessDialog;
begin
  Qaccess1 := TQaccess.Create(Application);
  Qaccess1.Hide;
  Qaccess1.ShowModal;
end;

procedure TQaccess.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

//--------------------------------------------------------
// CtH[̃tHgeIuWFNgɐݒ
//--------------------------------------------------------
procedure TQaccess.SetEachFont;
var fSize: Integer; fFont: TFont;
begin
  fFont := Form1.Font;

  Button_Cancel.Font := fFont;
  Button_DelDir.Font := fFont;
  Button_Ok    .Font := fFont;
  Button_RegDir.Font := fFont;
  Label1       .Font := fFont;
  LBox_DirList .Font := fFont;

  fSize := Form1.Font.Size - 2;
  if fSize > MaxDlgFsize then fSize := MaxDlgFsize;

  Button_Cancel.Font.Size := fSize;
  Button_DelDir.Font.Size := fSize;
  Button_Ok    .Font.Size := fSize;
  Button_RegDir.Font.Size := fSize;
  Label1       .Font.Size := fSize;
  LBox_DirList .Font.Size := fSize;
end;

procedure TQaccess.FormCreate(Sender: TObject);
begin
  SetEachFont;
end;

procedure TQaccess.FormDestroy(Sender: TObject);
begin
  F_Qaccess := False;
end;

procedure TQaccess.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if F_SelDir then
  begin
    case Key of
      vk_Delete: Button_DelDirClick(Sender);
      vk_Insert: Button_RegDirClick(Sender);
    end;
  end;
end;

end.
