unit SortProp;

interface

uses Windows, Messages, System.UITypes, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TSortProp = class(TForm)
    Button_Cancel: TButton;
    Button_Ok    : TButton;
    Btn_Date     : TRadioButton;
    Btn_Down     : TRadioButton;
    Btn_Ext      : TRadioButton;
    Btn_Name     : TRadioButton;
    Btn_NSrt     : TRadioButton;
    Btn_Shlw     : TRadioButton;
    Btn_Size     : TRadioButton;
    Btn_Up       : TRadioButton;
    GroupBox1    : TGroupBox;
    GroupBox2    : TGroupBox;
    GroupBox3    : TGroupBox;
    Label1       : TLabel;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure GetProperty;
    procedure SetButton;
  public
    { Public 錾 }
    procedure SetEachFont;
  end;

procedure ShowSortPropDialog;

var
  SortProp1: TSortProp;

implementation

{$R *.DFM}

uses Zfd;

//---------------------------------------------------------------------------------------------------------------------------------------------------

// _CAO\̏
procedure TSortProp.FormShow(Sender: TObject);
begin
  SortProp1.Caption := Form1.Caption;

  SetButton;

  F_SortPr := True;

  // \[gp_CAOpƂ
  Application.OnMessage := SortProp1.AppMessage;
end;

// e{^ݒ肷
procedure TSortProp.SetButton;
begin
  case tMode of
    tpExt : begin
              Btn_Ext .Checked := True;
              Btn_Ext .SetFocus;
            end;
    tpName: begin
              Btn_Name.Checked := True;
              Btn_Name.SetFocus;
            end;
    tpSize: begin
              Btn_Size.Checked := True;
              Btn_Size.SetFocus;
            end;
    tpDate: begin
              Btn_Date.Checked := True;
              Btn_Date.SetFocus;
            end;
  end;

  if F_Forward then Btn_Up  .Checked := True
  else              Btn_Down.Checked := True;

  if F_Shlwapi then Btn_Shlw.Checked := True
  else              Btn_NSrt.Checked := True;
end;

// e{^ݒ𓾂
procedure TSortProp.GetProperty;
begin
  if Btn_Ext .Checked then tMode := tpExt
  else
  if Btn_Name.Checked then tMode := tpName
  else
  if Btn_Size.Checked then tMode := tpSize
  else                     tMode := tpDate;

  F_Forward := Btn_Up.Checked;

  F_Shlwapi := Btn_Shlw.Checked;
end;

//--------------------------------------------------------
// CtH[̃L[͏
//--------------------------------------------------------
// {^ł̏sO
//--------------------------------------------------------
procedure TSortProp.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
  if Msg.message = WM_KEYDOWN then
  begin
    case Msg.wParam of
      vkReturn: begin
                  if Btn_Up  .Focused or
                     Btn_Down.Focused then
                  begin
                    // Anj{^ɓn
                  end
                  else
                  if Btn_Ext .Focused or
                     Btn_Name.Focused or
                     Btn_Size.Focused or
                     Btn_Date.Focused then
                  begin
                    if F_Forward then
                    begin
                      Btn_Up.Checked := True;
                      Btn_Up.SetFocus;

                      Handled := True;
                    end
                    else
                    begin
                      Btn_Down.Checked := True;
                      Btn_Down.SetFocus;

                      Handled := True;
                    end;
                  end;
                end;
      vk1     : begin
                  Btn_Shlw.Checked := True;

                  Handled := True;
                end;
      vk2     : begin
                  Btn_NSrt.Checked := True;

                  Handled := True;
                end;
      vkD     : begin
                  Btn_Down.Checked := True;
                  Btn_Down.SetFocus;

                  Handled := True;
                end;
      vkN     : begin
                  Btn_Name.Checked := True;
                  Btn_Name.SetFocus;

                  Handled := True;
                end;
      vkE     : begin
                  Btn_Ext.Checked := True;
                  Btn_Ext.SetFocus;

                  Handled := True;
                end;
      vkS     : begin
                  Btn_Size.Checked := True;
                  Btn_Size.SetFocus;

                  Handled := True;
                end;
      vkT     : begin
                  Btn_Date.Checked := True;
                  Btn_Date.SetFocus;

                  Handled := True;
                end;
      vkU     : begin
                  Btn_Up.Checked := True;
                  Btn_Up.SetFocus;

                  Handled := True;
                end;
    end;
  end;
end;

// nj{^̏
procedure TSortProp.Button_OkClick(Sender: TObject);
begin
  GetProperty;

  ModalResult := mrOK;
end;

// LZ{^̏
procedure TSortProp.Button_CancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure ShowSortPropDialog;
begin
  SortProp1 := TSortProp.Create(Application);
  SortProp1.ShowModal;
end;

procedure TSortProp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Release;
end;

//--------------------------------------------------------
// CtH[̃tHgeIuWFNgɐݒ
//--------------------------------------------------------
procedure TSortProp.SetEachFont;
var fSize: Integer; fFont: TFont;
begin
  fFont := Form1.Font;

  Button_Cancel.Font := fFont;
  Button_Ok    .Font := fFont;
  Btn_Date     .Font := fFont;
  Btn_Down     .Font := fFont;
  Btn_Ext      .Font := fFont;
  Btn_Name     .Font := fFont;
  Btn_NSrt     .Font := fFont;
  Btn_Shlw     .Font := fFont;
  Btn_Size     .Font := fFont;
  Btn_Up       .Font := fFont;
  GroupBox1    .Font := fFont;
  GroupBox2    .Font := fFont;
  GroupBox3    .Font := fFont;
  Label1       .Font := fFont;

  fSize := Form1.Font.Size - 2;
  if fSize > MaxDlgFsize then fSize := MaxDlgFsize;

  Button_Cancel.Font.Size := fSize;
  Button_Ok    .Font.Size := fSize;
  Btn_Date     .Font.Size := fSize;
  Btn_Down     .Font.Size := fSize;
  Btn_Ext      .Font.Size := fSize;
  Btn_Name     .Font.Size := fSize;
  Btn_NSrt     .Font.Size := fSize;
  Btn_Shlw     .Font.Size := fSize;
  Btn_Size     .Font.Size := fSize;
  Btn_Up       .Font.Size := fSize;
  GroupBox1    .Font.Size := fSize;
  GroupBox2    .Font.Size := fSize;
  GroupBox3    .Font.Size := fSize;
  Label1       .Font.Size := fSize;
end;

procedure TSortProp.FormCreate(Sender: TObject);
begin
  SetEachFont;
end;

procedure TSortProp.FormDestroy(Sender: TObject);
begin
  F_SortPr := False;
end;

end.
