unit Subroutines;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, ExtCtrls, Dialogs, ComCtrls, IOUtils, RegularExpressions, ShellAPI,
     Zfd;

function  ChangeUpperCaseDriveFileName(DirName: String): String;
function  CheckDirDelimiter(DirName: String): String;
procedure CopyDirectory  (SrcDir, DstDir: String);
procedure CopyFile       (SrcName, DstName: String; OverWrite: Boolean);
procedure DeleteDirectory(DstDir: String);
function  IsFilePathValid(StrText: String): Boolean;
procedure MakeDirectory  (DstDir: String);
procedure UpdateDirList  (DirName: String; DirList: TStringList);

function  FileListIndexOf(pName: String): Integer;
function  GetDriveList: String;
function  GetFileAttrDisp(iIndex: Integer): String;
function  GetFileListAttr(iIndex: Integer): Integer;
function  GetFileListName(iIndex: Integer): String;
function  GetFileListSize(iIndex: Integer): Int64;
function  GetFileListDate(iIndex: Integer): TDateTime;
function  Get_s1(iIndex: Integer): String;
function  Get_s2(iIndex: Integer): String;
function  Get_s3(iIndex: Integer): String;
function  Get_s4(iIndex: Integer): String;
function  IsFileListDir(iIndex: Integer): Boolean;
function  MinimizeString(s: String; Canvas: TCanvas; MaxLen: Integer): String;
procedure StartEditor(s: String);
procedure StartListFile;

function IsAnyMarked: Boolean;
function IsMarkedFile(iIndex: Integer): Boolean;
function GetMarkedNum: Integer;
function GetTextHeight(xFont: TFont): Integer;
function GetTextWidth (xFont: TFont): Integer;
function NaturalSort(Left, Right: Pointer): Integer;

const
  MaxHistNum = 100;

//var

implementation
{$WARN SYMBOL_PLATFORM OFF}

//---------------------------------------------------------------------------------------------------------------------------------------------------

procedure UpdateDirList(DirName: String; DirList: TStringList);
var n: Integer;
begin
  DirName := ChangeUpperCaseDriveFileName(DirName);
  DirName := IncludeTrailingPathDelimiter(DirName);

  n := DirList.IndexOf(DirName);      // ̂邩
  if n > -1 then DirList.Delete(n);   // ΍폜

  DirList.Insert(0, DirName);         // ԏɓ

  while DirList.Count > MaxHistNum do // ő吔𒴂Ō폜
  begin
    DirList.Delete(DirList.Count-1);
  end;
end;
{
  SysUtils.ChangeFileExt                t@C̊gqύX
  SysUtils.ChangeFilePath               t@C̃pXύX
  SysUtils.DeleteFile                   t@CfBXN폜
  SysUtils.ExcludeTrailingPathDelimiter ɋ؂LtĂȂpXԂ
  SysUtils.ExtractFileDir               t@ChCuƃfBNg𔲂o
  SysUtils.ExtractFileDrive             hCuo
  SysUtils.ExtractFileExt               t@C̊gqԂ
  SysUtils.ExtractFileName              t@C̖OƊgq𒊏o
  SysUtils.ExtractFilePath              t@C̃hCuƃfBNgԂ
  SysUtils.FileExists                   w肵t@C݂邩ǂ
  SysUtils.GetCurrentDir                ݂̃fBNg̖OԂ
  SysUtils.SetCurrentDir                ݂̃fBNgݒ肷
  TDirectory.Copy                       \[X fBNg̃RecAΏۃfBNgɃRs[
  TDirectory.CreateDirectory            w̃pXɐVfBNg쐬
  TDirectory.Delete                     w̃pXɂfBNg폜
  TFile.Copy                            w肳ꂽpXɃt@CRs[
  TPath.GetFileName                     fBNg̃tpXŌ̃f~^ȍ~o
}
//--------------------------------------------------------
// t@Cp
//--------------------------------------------------------

//--------------------------------------------------------
// \\폜ĕԂ
//--------------------------------------------------------
function CheckDirDelimiter(DirName: String): String;
begin
  Result := DirName;

  while (AnsiPos('\\', Result) > 0) do System.Delete(Result, AnsiPos('\\', Result), 1);
end;

//--------------------------------------------------------
// hCu啶ɂĕԂ
//--------------------------------------------------------
function ChangeUpperCaseDriveFileName(DirName: String): String;
var c: Char; s: String;
begin
  if DirName = '' then
  begin
    Result := '';
  end
  else
  begin
    s := ExtractFileDrive(AnsiUpperCase(DirName));
    if s = '' then
    begin
      Result := DirName;
    end
    else
    begin
      c := s[1];
      s := DirName;
      System.Delete(s, 1, 1);

      Result := c + s;
    end;
  end;
end;

function IsFilePathValid(StrText: String): Boolean;
begin
  // pXƂĎgp\`FbN
  Result := TPath.HasValidPathChars(StrText, True);
end;

function IsFileNameValid(StrText: String): Boolean;
begin
  // t@CƂĎgp\`FbN
  Result := TPath.HasValidFileNameChars(StrText, True);
end;

procedure CopyDirectory(SrcDir, DstDir: String);
begin
  // fBNg (TufBNg܂߂) Rs[
  TDirectory.Copy(SrcDir, DstDir);

  // 킹
  TDirectory.SetAttributes    (DstDir, TDirectory.GetAttributes    (SrcDir));
  TDirectory.SetCreationTime  (DstDir, TDirectory.GetCreationTime  (SrcDir));
  TDirectory.SetLastAccessTime(DstDir, TDirectory.GetLastAccessTime(SrcDir));
  TDirectory.SetLastWriteTime (DstDir, TDirectory.GetLastWriteTime (SrcDir));
end;

procedure CopyFile(SrcName, DstName: String; OverWrite: Boolean);
var sDir: String;
begin
  sDir := SysUtils.ExtractFilePath(DstName);

  if not TDirectory.Exists(sDir) then  // wfBNg݂邩mF
  begin
    // fBNg쐬
    TDirectory.CreateDirectory(sDir);
  end;

  // t@CRs[
  TFile.Copy(SrcName, DstName, OverWrite);
end;

procedure DeleteDirectory(DstDir: String);
begin
  if TDirectory.Exists(DstDir) then
  begin
    // fBNg (TufBNg܂߂) 폜
    TDirectory.Delete(DstDir, True);
  end;
end;

procedure MakeDirectory(DstDir: String);
begin
  if (not TDirectory.Exists(DstDir)) and  // ɎwfBNgȂmF
            IsFilePathValid(DstDir)  then // LȃpXmF
  begin
    // fBNg쐬
    TDirectory.CreateDirectory(DstDir);
  end;
end;

//-[낢]----------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------
// wTCY[...]tĕԂ
//--------------------------------------------------------
function MinimizeString(s: String; Canvas: TCanvas; MaxLen: Integer): String;
begin
  Result := s;

  if Canvas.TextWidth(s) <= MaxLen then Exit;

  while (MaxLen < Canvas.TextWidth(s + '...')) do
  begin
    SetLength(s, Length(s) - 1);
  end;

  Result := s + '...';
end;

//--------------------------------------------------------
// hCũXg쐬ĕԂ
//--------------------------------------------------------
function GetDriveList: String;
var i: Integer; LogDrives: Cardinal; DriveName: String;
begin
  // ݎgp\ȃfBXNhCũrbg}XN擾
  LogDrives := GetLogicalDrives;

@// hCu̗
  // hCu̍ő吔25(A - Z)
  DriveName := '[ ';

  for i := 0 to 25 do
  begin
@@if (LogDrives and (1 shl i)) <> 0 then DriveName := DriveName + Char(Ord('A') + i) + ' ';
  end;

  Result := DriveName + ']';
end;

//--------------------------------------------------------
//  t@CXg̖OƈvIndexԂ
//--------------------------------------------------------
function FileListIndexOf(pName: String): Integer;
var i: Integer;
begin
  Result := -1;

  with Form1.FileList do
  begin
    for i := 0 to Count - 1 do
    begin
      if PDataRec(Items[i])^.FileName = pName then
      begin
        Result := i;

        System.Break;
      end;
    end;
  end;
end;
{
faReadOnly  $00000001 ǂݎpt@C
faHidden    $00000002 Bt@C
faSysFile   $00000004 VXe t@C
faVolumeID  $00000008 {[ ID t@C
faDirectory $00000010 fBNg t@C
faArchive   $00000020 A[JCu t@C
faAnyFile   $0000003F ׂẴt@C
}
//--------------------------------------------------------
// ŏIύXp\
//--------------------------------------------------------
// s1Ԃ
//--------------------------------------------------------
function Get_s1(iIndex: Integer): String;
begin
  Result := FormatDateTime('yyyy.mm.dd  hh.nn.ss', PDataRec(Form1.FileList.Items[iIndex])^.FileDate);
end;

//--------------------------------------------------------
// fBNgp\
//--------------------------------------------------------
// s2Ԃ
//--------------------------------------------------------
function Get_s2(iIndex: Integer): String;
begin
  Result := '<dir>' + '  ' + Get_s1(iIndex) + ' ';
end;

//--------------------------------------------------------
// t@Cp\
//--------------------------------------------------------
// s3Ԃ
//--------------------------------------------------------
function Get_s3(iIndex: Integer): String;
begin
  Result := Get_s4(iIndex) + '  ' + Get_s1(iIndex) + ' ';
end;

//--------------------------------------------------------
// t@CTCY
//--------------------------------------------------------
// s4Ԃ
//--------------------------------------------------------
function Get_s4(iIndex: Integer): String;
begin
  Result := Format('%18.0n', [Double(PDataRec(Form1.FileList.Items[iIndex])^.FileSize)]);
end;

//--------------------------------------------------------
// wt@CfBNgۂԂ
//--------------------------------------------------------
function IsFileListDir(iIndex: Integer): Boolean;
var iAttr: Integer;
begin
  iAttr := PDataRec(Form1.FileList.Items[iIndex])^.FileAttr;

  Result := ((iAttr and faDirectory) = faDirectory);
end;

//--------------------------------------------------------
// Xg{bNXőIꂽt@C̑Ԃ
//--------------------------------------------------------
function GetFileAttrDisp(iIndex: Integer): String;
begin
  if IsFileListDir(iIndex) then Result := Get_s2(iIndex)
  else                          Result := Get_s3(iIndex);
end;

//--------------------------------------------------------
//  wt@C̑Ԃ
//--------------------------------------------------------
function GetFileListAttr(iIndex: Integer): Integer;
begin
  Result := PDataRec(Form1.FileList.Items[iIndex])^.FileAttr;
end;

//--------------------------------------------------------
//  wt@C̖OԂ
//--------------------------------------------------------
function GetFileListName(iIndex: Integer): String;
begin
  Result := PDataRec(Form1.FileList.Items[iIndex])^.FileName;
end;

//--------------------------------------------------------
// wt@C̃TCYԂ
//--------------------------------------------------------
function GetFileListSize(iIndex: Integer): Int64;
begin
  Result := PDataRec(Form1.FileList.Items[iIndex])^.FileSize;
end;

//--------------------------------------------------------
// wt@C̎ԂԂ
//--------------------------------------------------------
function GetFileListDate(iIndex: Integer): TDateTime;
begin
  Result := PDataRec(Form1.FileList.Items[iIndex])^.FileDate;
end;

//--------------------------------------------------------
// GfB^N
//--------------------------------------------------------
procedure StartEditor(s: String);
var Command: String; SI: TStartupInfo; PI: TProcessInformation;
begin
  Command := fEdit + ' ' + s;
  GetStartupInfo(SI);

  if not CreateProcess(nil, Pchar(Command), nil, nil, False, CREATE_DEFAULT_ERROR_MODE, nil, nil, SI, PI) then
  begin
    raise Exception.Create('GfB^NG[F' + IntToStr(GetLastError));
  end;
end;

//--------------------------------------------------------
// wt@CN
//--------------------------------------------------------
procedure StartListFile;
var s, Src: String; LhInstance: Cardinal;
begin
  s := GetFileListName(idxItem);

  // ShellExecute֐ŊgqɊ֘AtꂽAvN
  Src := fDir + s;

  if FileExists(Src) then
  begin
    LhInstance := ShellExecute(Form1.LBox_Files.Handle,
                               'open',
                               PChar(Src),
                               PChar(''),
                               nil,
                               SW_SHOW);

    if LhInstance <= 32 then
    begin
      MessageBox(Form1.LBox_Files.Handle, 'NɎs܂', 'G[', MB_ICONSTOP);
    end;
  end;
end;

//--------------------------------------------------------
// }[NꂽsۂԂ
//--------------------------------------------------------
function IsMarkedFile(iIndex: Integer): Boolean;
begin
  Result := PDataRec(Form1.FileList.Items[iIndex])^.Marked;
end;

//--------------------------------------------------------
// }[Nꂽs邩ۂԂ
//--------------------------------------------------------
function IsAnyMarked: Boolean;
var i: Integer;
begin
  Result := False;

  for i := 0 to Form1.FileList.Count - 1 do
  begin
    if IsMarkedFile(i) then
    begin
      Result := True;

      System.Break;
    end;
  end;
end;

//--------------------------------------------------------
// }[NꂽsԂ
//--------------------------------------------------------
function GetMarkedNum: Integer;
var i, n: Integer;
begin
  n := 0;

  for i := 0 to Form1.FileList.Count - 1 do
  begin
    if IsMarkedFile(i) then Inc(n);
  end;

  Result := n;
end;

//--------------------------------------------------------
// wtHg̕Ԃ
//--------------------------------------------------------
function GetTextHeight(xFont: TFont): Integer;
begin
  with TBitmap.Create do
  try
    Canvas.Font.Assign(xFont);
    Result := Canvas.TextHeight('0');

  finally
    Free;
  end;
end;

//--------------------------------------------------------
// wtHg̕Ԃ
//--------------------------------------------------------
function GetTextWidth(xFont: TFont): Integer;
begin
  with TBitmap.Create do
  try
    Canvas.Font.Assign(xFont);
    Result := Canvas.TextWidth('0');

  finally
    Free;
  end;
end;

//-[R\[g]------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------
// R\[gFShlwapi.dllgp
//--------------------------------------------------------
function StrCmpLogicalW(P1, P2: PWideChar): Integer;  stdcall; external 'Shlwapi.dll';

//--------------------------------------------------------
// R\[gFShlwapi.dllsgp
//--------------------------------------------------------
function NaturalSortSub(const S1, S2: String): Integer;
const
  RE_CHUNK  : String = '([\D]+|[\d]+)';
  RE_LETTERS: String = '\D+';
  RE_NUMBERS: String = '\d+';
var L, R, LChunk, RChunk: String; ReChunk, ReLetter, ReNumber: TRegEx;

  //------------------------------------------------------
  // ̐擪AA鐔܂͕擾
  //------------------------------------------------------
  function GetChunk(var S: String): String;
  var Match: TMatch;
  begin
    Match := ReChunk.Match(S);

    if Match.Success then
    begin
      Result := Match.Groups[0].Value;
      S      := S.Substring(Result.Length);
    end
    else
    begin
      Result := '';
    end;
  end;

//--------------------------------------------------------
// 𐔒lƂĔrāA
// S1Ƃ-1A
// S2Ƃ 1A
// Ƃ0Ԃ
//--------------------------------------------------------
  function CompareNum(const S1, S2: String): Integer;
  var Num1, Num2: Int64;
  begin
    Num1 := StrToInt64(S1);
    Num2 := StrToInt64(S2);

    if Num1 < Num2 then Result := -1
    else
    if Num1 > Num2 then Result :=  1
    else                Result :=  0;
  end;

begin
  Result := 0;
  L := S1;
  R := S2;
  ReChunk  := TRegEx.Create(RE_CHUNK);
  ReLetter := TRegEx.Create(RE_LETTERS);
  ReNumber := TRegEx.Create(RE_NUMBERS);

  while Result = 0 do
  begin
    if L.IsEmpty and R.IsEmpty then Exit(CompareStr(S1, S2));

    LChunk := GetChunk(L);
    RChunk := GetChunk(R);

    if ReLetter.Match(LChunk).Success and ReLetter.Match(RChunk).Success then
    begin
      Result := CompareStr(LChunk, RChunk);
    end
    else
    if ReNumber.Match(LChunk).Success and ReNumber.Match(RChunk).Success then
    begin
      Result := CompareNum(LChunk, RChunk);
    end
    else
    begin
      Result := CompareStr(LChunk, RChunk);
      if Result = 0 then Result := 1;
    end;
  end;
end;

//--------------------------------------------------------
// \[gɂ锻f
//--------------------------------------------------------
// @fBNgm tpExt/tpSize ł͖OŃ\[g
// At@CmŃTCYȂ疼OŃ\[g
//--------------------------------------------------------
function CaseoftMode(n1, n2, s1, s2, t1, t2: String; F_BothDir, F_BothFile: Boolean): Integer;
begin
  case tMode of
    tpExt : if F_BothDir then
            begin
              // OƓƂ
              if F_Shlwapi then
              begin
                if F_Forward then Result := StrCmpLogicalW(PWideChar(n1), PWideChar(n2))  // OE
                else              Result := StrCmpLogicalW(PWideChar(n2), PWideChar(n1)); // OEt
              end
              else
              begin
                if F_Forward then Result := NaturalSortSub(n1, n2)  // OE
                else              Result := NaturalSortSub(n2, n1); // OEt
              end;
            end
            else
            if F_Shlwapi then
            begin
              if F_Forward then Result := StrCmpLogicalW(PWideChar(ExtractFileExt(n1) + n1), PWideChar(ExtractFileExt(n2) + n2))  // gqE
              else              Result := StrCmpLogicalW(PWideChar(ExtractFileExt(n2) + n2), PWideChar(ExtractFileExt(n1) + n1)); // gqEt
            end
            else
            begin
              if F_Forward then Result := NaturalSortSub(ExtractFileExt(n1) + n1, ExtractFileExt(n2) + n2)  // gqE
              else              Result := NaturalSortSub(ExtractFileExt(n2) + n2, ExtractFileExt(n1) + n1); // gqEt
            end;
    tpName: if F_Shlwapi then
            begin
              if F_Forward then Result := StrCmpLogicalW(PWideChar(n1), PWideChar(n2))  // OE
              else              Result := StrCmpLogicalW(PWideChar(n2), PWideChar(n1)); // OEt
            end
            else
            begin
              if F_Forward then Result := NaturalSortSub(n1, n2)  // OE
              else              Result := NaturalSortSub(n2, n1); // OEt
            end;
    tpSize: if F_BothDir then
            begin
              // OƓƂ
              if F_Shlwapi then
              begin
                if F_Forward then Result := StrCmpLogicalW(PWideChar(n1), PWideChar(n2))  // OE
                else              Result := StrCmpLogicalW(PWideChar(n2), PWideChar(n1)); // OEt
              end
              else
              begin
                if F_Forward then Result := NaturalSortSub(n1, n2)  // OE
                else              Result := NaturalSortSub(n2, n1); // OEt
              end;
            end
            else
            if F_Shlwapi then
            begin
              if F_Forward then Result := StrCmpLogicalW(PWideChar(s1), PWideChar(s2))  // TCYE
              else              Result := StrCmpLogicalW(PWideChar(s2), PWideChar(s1)); // TCYEt

              // TCYꍇ
              if Result = 0 then
              begin
                if F_Forward then Result := StrCmpLogicalW(PWideChar(n1), PWideChar(n2))  // OE
                else              Result := StrCmpLogicalW(PWideChar(n2), PWideChar(n1)); // OEt
              end;
            end
            else
            begin
              if F_Forward then Result := NaturalSortSub(s1, s2)  // TCYE
              else              Result := NaturalSortSub(s2, s1); // TCYEt

              // TCYꍇ
              if Result = 0 then
              begin
                if F_Forward then Result := NaturalSortSub(n1, n2)  // OE
                else              Result := NaturalSortSub(n2, n1); // OEt
              end;
            end;
    tpDate: if F_Shlwapi then
            begin
              if F_Forward then Result := StrCmpLogicalW(PWideChar(t1), PWideChar(t2))  // tE
              else              Result := StrCmpLogicalW(PWideChar(t2), PWideChar(t1)); // tEt
            end
            else
            begin
              if F_Forward then Result := NaturalSortSub(t1, t2)  // tE
              else              Result := NaturalSortSub(t2, t1); // tEt
            end;
    else    Result := 0;
   end;
end;

//--------------------------------------------------------
// fBNgm̔r
//--------------------------------------------------------
// @MaskD
// AȂt@CƓ
//--------------------------------------------------------
function NaturalSortDirSub(a1, a2: Integer; n1, n2, s1, s2, t1, t2: String): Integer;
var Mask: Integer;
begin
  Mask := faReadOnly + faHidden + faSysFile;

  if (a1 and Mask) > (a2 and Mask) then Result := -1
  else
  if (a1 and Mask) < (a2 and Mask) then Result :=  1
  else
  begin
    Result := CaseoftMode(n1, n2, s1, s2, t1, t2, True, False);
  end;
end;

//--------------------------------------------------------
// t@Cm̔r
//--------------------------------------------------------
function NaturalSortFileSub(n1, n2, s1, s2, t1, t2: String): Integer;
begin
  Result := CaseoftMode(n1, n2, s1, s2, t1, t2, False, True);
end;

//--------------------------------------------------------
// WFlbNX TList ̃\[g֐
//--------------------------------------------------------
// F_Shlwapi  Shlwapi.dll gp邩ۂ
//--------------------------------------------------------
// F_Forward ͐Et
// tMode     ͎ʁiOETCYEԁj
//--------------------------------------------------------
function NaturalSort(Left, Right: Pointer): Integer;
var a1, a2: Integer; n1, n2, s1, s2, t1, t2: String;
begin
  Result := 0; // Dummy

  try
    a1 :=               PDataRec(Left )^.FileAttr;
    a2 :=               PDataRec(Right)^.FileAttr;
    n1 :=               PDataRec(Left )^.FileName;
    n2 :=               PDataRec(Right)^.FileName;
    s1 :=      IntToStr(PDataRec(Left )^.FileSize);
    s2 :=      IntToStr(PDataRec(Right)^.FileSize);
    t1 := DateTimeToStr(PDataRec(Left )^.FileDate);
    t2 := DateTimeToStr(PDataRec(Right)^.FileDate);

    if n1 = '..' then
    begin
      Result := -1;
    end
    else
    if n2 = '..' then
    begin
      Result := 1;
    end
    else
    if (a1 and faDirectory) = faDirectory then
    begin
      if (a2 and faDirectory) = faDirectory then
      begin
        // fBNg̏ꍇ
        Result := NaturalSortDirSub(a1, a2, n1, n2, s1, s2, t1, t2);
      end
      else
      begin
        // 1=fBNg, 2=t@C̏ꍇ
        Result := -1;
      end;
    end
    else
    if (a2 and faDirectory) = faDirectory then
    begin
      // 1=t@C, 2=fBNg̏ꍇ
      Result := 1;
    end
    else
    begin
      // t@C̏ꍇ
      Result := NaturalSortFileSub(n1, n2, s1, s2, t1, t2);
    end;
  except
  end;
end;

end.

